/** SGX

The   sss    gggg x   x   
     s      g      x x    Engine
      sss   g  gg   x
         s  g   g  x x          Copyright 1995-2009.
     ssss    gggg x   x         Steven Goodwin. All Rights Reserved.
    
This version has been released under the GNU Public License v2.0.

Please see the license files for details.

File: sgx/include/sgx/audio/sampledata.hpp

*/

#ifndef SGX_AUDIO_SAMPLE_DATA_HPP
#define SGX_AUDIO_SAMPLE_DATA_HPP	1

class CLogicalChannel;

class CSampleData : public CGameHandler
{
public:
	CSampleData(const sgxString &filename, const CSGXAudioEngine::ResourceContext context = CSGXAudioEngine::eDefault);

	virtual void		setNormalizationGroup(tUINT32 grp);
	virtual tUINT32		getNormalizationGroup() const;

	virtual tREAL32		getDuration() const;
	
	virtual tREAL32		getOuterRange() const;
	virtual tREAL32		getInnerRange() const;
	virtual void		setOuterRange(tREAL32 range);
	virtual void		setInnerRange(tREAL32 range);

protected:
	virtual		CLogicalChannel *getLogicalChannel(CLogicalChannel *pLogicalChannel=NULL);
	virtual		CDeviceChannel *play(CLogicalChannel *pLogicalChannel=NULL);

private:
	CSampleData(){}
	tREAL32		m_fInner;
	tREAL32		m_fOuter;
	tUINT32		m_NormalizationGroup;

	friend class CSGXAudioEngine;
};

#endif /* SGX_AUDIO_SAMPLE_DATA_HPP */
